﻿#Region " Imports "

Imports System.Globalization
Imports System.IO

#End Region

Public Class InfoWad

#Region " Fields "

    Private mTitleId As String
    Private mRegion As String
    Private mBlocs As Double
    Private mFolder As String
    Private mDataFiles As Integer

#End Region

#Region " Properties "

    Public Property TitleId() As String
        Get
            Return mTitleId
        End Get

        Set(ByVal value As String)
            mTitleId = value
        End Set
    End Property

    Public Property Region() As String
        Get
            Return mRegion
        End Get

        Set(ByVal value As String)
            mRegion = value
        End Set
    End Property

    Public Property Blocs() As Double
        Get
            Return mBlocs
        End Get

        Set(ByVal value As Double)
            mBlocs = value
        End Set
    End Property

    Public Property Folder() As String
        Get
            Return mFolder
        End Get

        Set(ByVal value As String)
            mFolder = value
        End Set
    End Property

    Public Property DataFiles() As Integer
        Get
            Return mDataFiles
        End Get

        Set(ByVal value As Integer)
            mDataFiles = value
        End Set
    End Property

#End Region

#Region " Constructor "

    Public Sub New(ByVal fileName As String)
        Try
            Using input As New FileStream(fileName, FileMode.Open)
                Dim bytes(3) As Byte

                ' Get Folder and Title ID
                With input
                    .Seek(3100, SeekOrigin.Begin)
                    .Read(bytes, 0, 4)
                End With

                mFolder = String.Format(CultureInfo.InvariantCulture, "{0}{1}{2}{3}", bytes(0).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c), bytes(1).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c), bytes(2).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c), bytes(3).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c))

                With input
                    .Seek(3104, SeekOrigin.Begin)
                    .Read(bytes, 0, 4)
                End With

                mTitleId = String.Format(CultureInfo.InvariantCulture, "{0}{1}{2}{3}", Convert.ToChar(bytes(0)), Convert.ToChar(bytes(1)), Convert.ToChar(bytes(2)), Convert.ToChar(bytes(3)))
                mFolder &= String.Format(CultureInfo.InvariantCulture, "\{0}{1}{2}{3}", bytes(0).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c), bytes(1).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c), bytes(2).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c), bytes(3).ToString("X", CultureInfo.InvariantCulture).PadLeft(2, "0"c))

                ' Get Region
                With input
                    .Seek(3740, SeekOrigin.Begin)
                    .Read(bytes, 0, 2)
                End With

                Dim region As UInt16 = Convert.ToUInt16((bytes(0) * 256) + bytes(1))

                Select Case region
                    Case 0
                        mRegion = "NTSC-J"
                    Case 1
                        mRegion = "NTSC-U"
                    Case 2
                        mRegion = "PAL"
                    Case 3
                        mRegion = "Region Free"
                    Case Else
                        mRegion = "Unknown"
                End Select

                ' Get Data Files
                With input
                    .Seek(64, SeekOrigin.Current) ' Position = 3806
                    .Read(bytes, 0, 4)
                End With

                Dim apps As UInt16 = Convert.ToUInt16((bytes(0) * 256) + bytes(1))

                mDataFiles = apps

                ' Get Blocks
                input.Seek(2, SeekOrigin.Current) ' Position = 3812

                Dim maxApps As Integer = apps - 1
                Dim temp1 As Byte
                Dim temp2 As UInt32
                Dim temp3 As UInt32 = 0

                For count = 0 To maxApps
                    With input
                        .Seek(6, SeekOrigin.Current)
                        .Read(bytes, 0, 1)

                        temp1 = bytes(0)

                        .Seek(5, SeekOrigin.Current)
                        .Read(bytes, 0, 4)

                        temp2 = Convert.ToUInt32(Math.Round(Convert.ToDouble((((bytes(0) * 16777216.0) + (bytes(1) * 65536.0)) + (bytes(2) * 256)) + bytes(3))))

                        If temp1 = 0 Then
                            temp3 += temp2
                        End If

                        .Seek(20, SeekOrigin.Current)
                    End With
                Next

                mBlocs = Convert.ToDouble(Convert.ToInt32(Convert.ToDouble((Convert.ToDouble(temp3)) / 131072.0)) + 1.0)
            End Using

        Catch ex As FileNotFoundException

        Catch ex As Exception
        End Try
    End Sub

#End Region

End Class
